program PetitExe;

uses
  Windows, Messages ;

{$R *.RES}
const
  NOM   : PChar = 'Petit exe';
  TITRE : PChar = 'Application disposant d''un executable trs petit';

  IDI_FENETRE_ICONE               = 101;        //  Handle de l'icone
  IDD_FENETRE                     = 102;        //  Handle de la fenetre
  IDR_FENETRE_ACCEL               = 103;        //  Handle des accelerateurs
  IDC_LISTBOX1                    = 1000;       //  Handle des ListBox
  IDC_LISTBOX2                    = 1001;       //
  IDC_LISTBOX3                    = 1002;       //
  IDC_QUITTER                     = 2;          //  Handle des boutons
  IDC_BOUTON1                     = 3;          //
  IDC_BOUTON2                     = 4;          //

var
  g_hDlg : HWND;

// *************************************************************
// *    Fonction d'exemple qui ajoute un objet dans ListBox2   *
// *************************************************************
procedure AjouteObjet1 ;
var
  hWndDeviceList : HWND;
begin
  hWndDeviceList := GetDlgItem( g_hDlg, IDC_LISTBOX2);
    SendMessage( hWndDeviceList, LB_ADDSTRING, 0, LPARAM( Pchar('Nouvelle objet'))) ;
end ;

procedure AjouteObjet2 ;
var
  hWndDeviceList : HWND;
begin
  hWndDeviceList := GetDlgItem( g_hDlg, IDC_LISTBOX3);
    SendMessage( hWndDeviceList, LB_ADDSTRING, 0, LPARAM( Pchar('Nouvelle objet'))) ;
end ;

// *************************************************************
// * OnInitDialog : Initialisation des objets                  *
// *************************************************************
procedure OnInitObjets;
var
  h_Inst : HInst;
  h_Icon : HICON;
  hWndDeviceList : HWND;
  i : UINT;
  dwCurrentSelect : DWord;
begin
  // Chargement de l'cone
{$ifdef __WIN64}
  h_Inst := GetWindowLongPtr( g_hDlg, GWLP_HINSTANCE );
{$else}
  h_Inst := GetWindowLong( g_hDlg, GWL_HINSTANCE );
{$endif}
  h_Icon := LoadIcon( h_Inst, MAKEINTRESOURCE( IDI_FENETRE_ICONE ) );

  // Configure l'cone
  PostMessage( g_hDlg, WM_SETICON, ICON_BIG,   LPARAM( h_Icon ) );  // La grande
  PostMessage( g_hDlg, WM_SETICON, ICON_SMALL, LPARAM( h_Icon ) );  // La Petite

  // Remplissage des ListBox
  hWndDeviceList := GetDlgItem( g_hDlg, IDC_LISTBOX1 );
  for i := 0 to  10 do
  begin
    SendMessage( hWndDeviceList, LB_ADDSTRING, 0, LPARAM( Pchar('Elements ListBox'))) ;
    SendMessage( hWndDeviceList, LB_SETITEMDATA, i, LPARAM( i+1 ) );
  end;

  // Objet slctionnez  l'ouverture de la fenetre
  dwCurrentSelect := 0;
  SendMessage( hWndDeviceList, LB_SETCURSEL, dwCurrentSelect, 0);

  SetFocus( hWndDeviceList );
end;

// **********************************************************************
// * InfoDlgProc : Procedure appel par Windows pour gerer les messages *
// **********************************************************************
function InfoDlgProc( hDlg : HWND; amessage : UINT; wParm : WPARAM; lParm : LPARAM ) : Boolean; stdcall;
begin
  case (amessage) of
    WM_INITDIALOG:
    begin
      g_hDlg := hDlg; // Slction du HWND global
      OnInitObjets;   // Initialis le contenu des ListBox
    end;

    WM_COMMAND:
    begin
      case LOWORD(wParm) of
        IDCANCEL:
        begin
          EndDialog( hDlg, IDCANCEL );
        end;

        IDC_BOUTON1:
        begin
          // Action sur le 'bouton 1' //
          AjouteObjet1 ;
        end;

        IDC_BOUTON2:
        begin
          // Action sur le 'bouton 2' //
          AjouteObjet2 ;
        end;

        IDC_LISTBOX1:
        begin
          case HIWORD(wParm) of
            LBN_SELCHANGE:
            begin
             /// Changement de slection dans listbox1 ///
            end;

            else
            begin
              result := FALSE; // Message sans Handle
              exit;
            end;
          end;
        end;

        else
        begin
          result := FALSE; // Message sans Handle
          exit;
        end;
      end;
    end;

    else
    begin
      result := FALSE; // Message sans Handle
      exit;
    end;
  end;

  result := TRUE; // Message avec Handle
end;


// ******************************************************
// *        Routine premire appell par windows        *
// ******************************************************
begin
  // Afficher la fenetre  l'cran.
  DialogBox( hInstance, MAKEINTRESOURCE(IDD_FENETRE), GetDesktopWindow, @InfoDlgProc );
end.
